# coding: utf-8

"""
    Mail-in-a-Box

    Mail-in-a-Box API HTTP specification.  # Introduction This API is documented in [**OpenAPI format**](http://spec.openapis.org/oas/v3.0.3). ([View the full HTTP specification](https://raw.githubusercontent.com/mail-in-a-box/mailinabox/api-spec/api/mailinabox.yml).)  All endpoints are relative to `https://{host}/admin` and are secured with [`Basic Access` authentication](https://en.wikipedia.org/wiki/Basic_access_authentication). If you have multi-factor authentication enabled, authentication with a `user:password` combination will fail unless a valid OTP is supplied via the `x-auth-token` header. Authentication via a `user:user_key` pair is possible without the header being present.   # noqa: E501

    The version of the OpenAPI document: 0.51.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mailinabox_api.configuration import Configuration


class StatusEntryExtra(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"monospace": "bool", "text": "str"}

    attribute_map = {"monospace": "monospace", "text": "text"}

    def __init__(
        self, monospace=None, text=None, local_vars_configuration=None
    ):  # noqa: E501
        """StatusEntryExtra - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._monospace = None
        self._text = None
        self.discriminator = None

        self.monospace = monospace
        self.text = text

    @property
    def monospace(self):
        """Gets the monospace of this StatusEntryExtra.  # noqa: E501


        :return: The monospace of this StatusEntryExtra.  # noqa: E501
        :rtype: bool
        """
        return self._monospace

    @monospace.setter
    def monospace(self, monospace):
        """Sets the monospace of this StatusEntryExtra.


        :param monospace: The monospace of this StatusEntryExtra.  # noqa: E501
        :type: bool
        """
        if (
            self.local_vars_configuration.client_side_validation and monospace is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `monospace`, must not be `None`"
            )  # noqa: E501

        self._monospace = monospace

    @property
    def text(self):
        """Gets the text of this StatusEntryExtra.  # noqa: E501


        :return: The text of this StatusEntryExtra.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this StatusEntryExtra.


        :param text: The text of this StatusEntryExtra.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation and text is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `text`, must not be `None`"
            )  # noqa: E501

        self._text = text

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StatusEntryExtra):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StatusEntryExtra):
            return True

        return self.to_dict() != other.to_dict()
