# coding: utf-8

"""
    Mail-in-a-Box

    Mail-in-a-Box API HTTP specification.  # Introduction This API is documented in [**OpenAPI format**](http://spec.openapis.org/oas/v3.0.3). ([View the full HTTP specification](https://raw.githubusercontent.com/mail-in-a-box/mailinabox/api-spec/api/mailinabox.yml).)  All endpoints are relative to `https://{host}/admin` and are secured with [`Basic Access` authentication](https://en.wikipedia.org/wiki/Basic_access_authentication). If you have multi-factor authentication enabled, authentication with a `user:password` combination will fail unless a valid OTP is supplied via the `x-auth-token` header. Authentication via a `user:user_key` pair is possible without the header being present.   # noqa: E501

    The version of the OpenAPI document: 0.51.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mailinabox_api.configuration import Configuration


class SystemBackupConfigUpdateRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "target": "str",
        "target_user": "str",
        "target_pass": "str",
        "min_age": "int",
    }

    attribute_map = {
        "target": "target",
        "target_user": "target_user",
        "target_pass": "target_pass",
        "min_age": "min_age",
    }

    def __init__(
        self,
        target=None,
        target_user=None,
        target_pass=None,
        min_age=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """SystemBackupConfigUpdateRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._target = None
        self._target_user = None
        self._target_pass = None
        self._min_age = None
        self.discriminator = None

        self.target = target
        self.target_user = target_user
        self.target_pass = target_pass
        self.min_age = min_age

    @property
    def target(self):
        """Gets the target of this SystemBackupConfigUpdateRequest.  # noqa: E501


        :return: The target of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this SystemBackupConfigUpdateRequest.


        :param target: The target of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation and target is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `target`, must not be `None`"
            )  # noqa: E501

        self._target = target

    @property
    def target_user(self):
        """Gets the target_user of this SystemBackupConfigUpdateRequest.  # noqa: E501


        :return: The target_user of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._target_user

    @target_user.setter
    def target_user(self, target_user):
        """Sets the target_user of this SystemBackupConfigUpdateRequest.


        :param target_user: The target_user of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation and target_user is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `target_user`, must not be `None`"
            )  # noqa: E501

        self._target_user = target_user

    @property
    def target_pass(self):
        """Gets the target_pass of this SystemBackupConfigUpdateRequest.  # noqa: E501


        :return: The target_pass of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._target_pass

    @target_pass.setter
    def target_pass(self, target_pass):
        """Sets the target_pass of this SystemBackupConfigUpdateRequest.


        :param target_pass: The target_pass of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation and target_pass is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `target_pass`, must not be `None`"
            )  # noqa: E501

        self._target_pass = target_pass

    @property
    def min_age(self):
        """Gets the min_age of this SystemBackupConfigUpdateRequest.  # noqa: E501


        :return: The min_age of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :rtype: int
        """
        return self._min_age

    @min_age.setter
    def min_age(self, min_age):
        """Sets the min_age of this SystemBackupConfigUpdateRequest.


        :param min_age: The min_age of this SystemBackupConfigUpdateRequest.  # noqa: E501
        :type: int
        """
        if (
            self.local_vars_configuration.client_side_validation and min_age is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `min_age`, must not be `None`"
            )  # noqa: E501
        if (
            self.local_vars_configuration.client_side_validation
            and min_age is not None
            and min_age < 1
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `min_age`, must be a value greater than or equal to `1`"
            )  # noqa: E501

        self._min_age = min_age

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemBackupConfigUpdateRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemBackupConfigUpdateRequest):
            return True

        return self.to_dict() != other.to_dict()
